/**
 * This class can build change notifications for display in scenes.
 */
function ChangeNotificationBuilder() {
    // PRIVATE MEMBERS \\       var private = "test";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds the body for the tooltip of the changes.
     * @param {array} changes The Changes-array.
     * @returns {string} HTML describing the tooltip body.
     */
    function buildBody(changes) {
        var body = "";
        for (var i in changes) {
            body += changes[i].toHtml();
        }
        return body;
    }

    // PUBLIC MEMBERS \\        this.public = "test";


    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds a notification of a bunch of changes to display in a scene.
     * @param {array} changes An array of Change objects describing what changes occured.
     * @returns {string} HTML describing the changes.
     */
    this.buildNotification = function (changes) {
        var change = buildBody(changes);
        return `<div class="text center">` + global.ui.makeStaticToolTip(change, false, false, "width: auto; display: inline-block; background-color: transparent;") + `</div>`;
    };
}
