/**
 * Noon three of Varanar.
 */
function VaranarSoupKitchen() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var sceneId = "VaranarSoupKitchen";
    var sceneName = "Varanar, Noon Three";
    var sceneSubfolder = "Varanar/DayThree";
    var ctrl = new VaranarSoupKitchenController(sceneId);
    var arrival = new VaranarSoupKitchenArrival(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Sets all the required global variables such as scene id, scene name,
     * scene stack and theme.
     */
    function setGlobals() {
        global.currentScene = that.id;
        global.currentSceneName = that.name;
        global.currentSceneFolder = that.subfolder ? that.subfolder : "";
        global.kobold.history.addToSceneStack(that.id);
    }

    /**
     * Builds the tab as a HTML string.
     * @returns {string} The tab, as a HTML string.
     */
    function buildTab() {
        var tab = global.ui.buildGenericHeader();
        tab += global.parser.parse(`[t]Varanar[/t]`);
        tab += global.parser.parse(`[st]Noon three[/st]`);
        tab += arrival.build();
        tab += global.ui.buildGenericFooter();
        return tab;
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = sceneId;
    this.name = sceneName;
    this.subfolder = sceneSubfolder;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this scene.
     */
    this.load = function () {
        setGlobals();
        var tab = buildTab();
        global.ui.loadToMain(tab);
        arrival.registerListeners();
        ctrl.autosave();
    };
}

global.sceneLoader.queueRegister(function () {
    var scene = new VaranarSoupKitchen();
    global.sceneLoader.registerScene(scene.id, scene);
});
