/**
 * Invited section of Varanar, Noon Three.
 * @param {VaranarSoupKitchenController} controller The Varanar, Noon Three controller.
 */
function VaranarSoupKitchenTruthSucceed(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.serveChoice;
    var changeController = false;

    var autoContinue = true;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.serveChoices;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var paid = global.kobold.history.shared.debtCollector.paid;
        var toReturn = `[p]
                            You tell the man the truth.
                            You're ${paid ? `heavily` : ``} indebted to the Three-Tailed Rat Clan, and are trying to save up some money to pay them off.
                            You [i]could[/i] use your gold to buy food for yourself,
                            but you don't [b]dare[/b] think of the consequences should the clan catch you empty-handed.
                            Worse yet, if one of them finds you spending coins that should belong to [b]them[/b], they'd probably [b]torture[/b] you to death for that.
                            So, here you are, hoping for some food that [i]won't[/i] lead to your slow and painful [b]death[/b].
                        [/p]
                        [p]
                            "[color=ppink]Hmph.
                            I've heard many a [i]kuhbold[/i] claim tah be hounded by this [i]gang[/i].
                            [b]Lying.[/b]
                            That's one thing yer kind is good at, isn't it?
                            How do I know you're not tellin' meh a lie?
                            If you're carryin' that gold around for, surely you know exactly [b]who[/b] it is you owe money to, right?
                            Well then, who is the leader of this so-called [i]Three-Tailed Rat Clan[/i]?[/color]"
                        [/p]
                        [p]
                            That's easy enough.
                            The Three-Tailed Rat is the leader of the clan.
                            That's why it's called the [i]Three-Tailed Rat Clan[/i].
                            Because it's lead by the Three-Tailed Rat.
                            "[color=ppink]That's a pretty stupid name.
                            Dumb enough to have been thought up by a [i]kuhbold[/i] like you.[/color]"
                            Another pointless accusation.
                        [/p]
                        [p]
                            You say you think the Three-Tailed Rat is [b]actually[/b] a rat with three tails, which would explain the name, but you're not really sure.
                            Nobody knows his true identity, and he rarely ever shows his face.
                            Besides, outside of the leader, the gang [b]is[/b] completely comprised of kobolds such as yourself.
                            It's not unreasonable to assume that [i]they[/i] came up with the name.
                            "[color=ppink]Alright, alright.
                            Cease yer yappin'.
                            You've convinced me.
                            Truth be told, the less ah know about these [i]clans[/i], the better.
                            Wouldn't want to rub anyone the wrong way in this city.
                            Could end up [b]dead[/b] before ah even get evicted.
                            Anyway, lemme get ye somethin' tah eat.[/color]"
                        [/p]
                        [p]
                            Patting you on the head, the fat man steps behind the counter,
                            opens up a cupboard, and produces a rusty metal pot half-filled with day-old soup.
                            You take a seat at the table nearest to you.
                            The sheep uses a wooden ladle to scoop some soup onto a deep plate,
                            having a quick taste of his own culinary prowess in the process.
                            His face scrunches up, signalling his disgust.
                            If [b]he[/b] doesn't like it, you very much so doubt [b]you[/b] will.
                        [/p]
                        [p]
                            Your dinner prepared, your host brings it over to your table.
                            He crudely tosses the plate in front of you, the viscous, red liquid within barely contained, almost splashing out onto you.
                            It looks to be some kind of [i]tomato[/i] soup, with chunks of what you presume to once have been [i]vegetables[/i].
                            Having served you your meal, the half-naked caprine takes a seat opposite to you, chair creaking loudly under his weight.
                        [/p]
                        [p]
                            The sheep reaches into the wool around his neck, and fetches out something you hadn't even noticed before:
                            a small pouch, similar to your coin-purse, almost [i]identical[/i].
                            He places the bag on the table.
                            "[color=ppink]Y'see this here?
                            It's a memento.
                            Wedding ring.
                            Belonged to mah waif.
                            Most beautiful ewe in all of the world, she was.
                            Not too [i]faithful[/i],
                            but I looked past those flaws to see the [b]diamond[/b] hidden underneath all the layers of foolin' 'round with the neighbours.
                            It was [b]her[/b] idea to start this here soup kitchen, and in her memory I continued the business.
                            'Till yesterday, that is.[/color]"
                        [/p]
                        [p]
                            A sudden loud noise from the back of the building interrupts the chubby man's sad story.
                            Sounds like something [i]falling[/i] and [b]breaking[/b].
                            The caprine rises to his hooves.
                            "[color=ppink]Baa~aah, it's probably those [b]filthy[/b] thieves again.
                            You enjoy yer meal, [i]kuhbold[/i].
                            I'll go scare'em off.[/color]"
                        [/p]
                        [p]
                            That being said, the sheep rushes behind the counter once more,
                            before disappearing into a side room, leaving you all alone with your plate of [i]slop[/i].
                            Soon after, you hear his loud, profanity-filled yelling along with angry bleating directed at whoever attempted to sneak inside.
                            Looks like the fat man forgot the bag with the ring in on the table.
                            It'd be a shame if someone [i]took it[/i].
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
